from Products.CMFCore.utils import getToolByName
from Products.CMFCore.DirectoryView import addDirectoryViews
from Products.Webstats import product_globals
from Products.ExternalMethod.ExternalMethod import manage_addExternalMethod

from StringIO import StringIO
import string

import os

def install(self):
  # Register skin layer
  directory_name = 'webstats'
  out = StringIO()   # setup stream for status messages
  portal = getToolByName(self, 'portal_url').getPortalObject()

  # Setup the skins
  skinstool = getToolByName(self, 'portal_skins')
  if directory_name not in skinstool.objectIds():
    # We need to add filesystem directory views for any
    # directory in out skins/ directory 
    addDirectoryViews(skinstool, 'skins', product_globals)
    out.write("Added %s directory view to portal_skins\n" % directory_name)

    # Now we need to go through the skin configurations
    # and insert directory_name into the configuration
    skins = skinstool.getSkinSelections()
    for skin in skins:
      path = skinstool.getSkinPath(skin)
      path = map(string.strip, string.split(path,','))
      if directory_name not in path:
        try: path.insert(path.index('custom')+1, directory_name)
	except ValueError:
	  path.append(directory_name)
	path = string.join(path, ', ')  
	# addSkinSelection will replace existing skins as well
	skinstool.addSkinSelection(skin, path)
	out.write("Added %s to %s skin\n" % (directory_name, skin))
      else:
        out.write("Skipping %s skin, %s is already set up\n" % (skin, directory_name))
	
  # Create folders
  try: portal.invokeFactory(id="webstats", type_name="Folder")
  except: pass  
  wfolder = getattr(portal, "webstats")
  try: wfolder.invokeFactory(id="images", type_name="Folder")
  except: pass
  ifolder = getattr(wfolder, "images")

  # Add the external method to handle all actions
  try: manage_addExternalMethod(wfolder, "webstatsAct", "", "Webstats.webstats", "webstatsAct")
  except: pass
  out.write("External Method successfuly created")
  
  # Add page templates 
  product_path = "./Products/Webstats/plone-content/"
  for f in os.listdir(product_path):
    (d, ext) = os.path.splitext(f)
    if ext == ".pt":
      fcontent = string.join(open(product_path+f, "r").readlines())
      fid = f.replace(ext, "")
      try: wfolder.manage_addProduct['PageTemplates'].manage_addPageTemplate(id=fid, text=fcontent)
      except: pass
      out.write("Page template \"%s\"successfuly created\n" % fid)
  
  # Add images
  images_path = product_path+"images/"    
  for f in os.listdir(images_path):
    (d, ext) = os.path.splitext(f)
    fcontent = open(images_path+f, "rb").read()
    try: ifolder.manage_addImage(id=f, file=fcontent)
    except: pass
    out.write("Image \"%s\" successfuly created\n" % f)
    
  # Return printed content
  return out.getvalue() 
  
