#!/bin/bash
# update.sh: updates webstats for a single site

# Author: Maurizio Pinotti <maurizio@pinottinet.com>
# Date: March 2006
# Updated: May 2006

# $1 must be Report Magic's path
# $2 must be the site name without extension
# Notice that <name>.ini must exists in ./conf/
 
cd $1
site=./conf/$2.ini
if [ -r $site ]
then
	echo "Updating webstats for site '$1'..."
	perl rmagic.pl -statistics_Include="$site"
	exit 0
else
	echo "Script usage: $0 PATH CONF_FILE"
	echo "Eg. $0 `pwd` sap (./conf/sap.ini MUST exists)"
	exit 1
fi

